%include "rw32-2018.inc"

; Ukol: Vypocitejte obsah trojuhelniku pres uhel a dve strany.
; Trojuhelnik ma strany a, b, c. Strany "c" a "b" sviraji uhel alpha,
; "a" a "c" uhel beta a "b" a "a" uhel gamma.
; Vzorec:
;   S = 0.5*a*b*sin(gamma)
; Uhel uvazujte ve stupnich. Soucet velikosti vnitrnich uhlu je 180 stupnu.
; Zkontrolujte, zda velikost zadaneho uhlu neprekracuje tuto hodnotu.
;
; Vstup: 3 cisla (uzivatelsky vstup) - uhel gamma, strana a, strana b.
; Vystup: vypocteny obsah (vypis na obrazovku).
; Postupujte dle instrukci v kodu.


section .data
; retezce pro vypis
s_uhel       db "Zadejte velikost uhlu gamma []",EOL, 0
s_strana_a   db "Zadejde delku strany a [cm]",EOL, 0
s_strana_b   db "Zadejde delku strany b [cm]",EOL,0
s_vysledek   db "Obsah trojuhelniku je ",0
s_jednotka   db " cm^2",EOL,0

; promenne pro funkci mezikruzi
r            dd 5.8  ; cm
R            dd 12.6 ; cm
s_obsah      db "Obsah mezikruzi je [cm^2]: ", 0

; promenne pro funkci trojuhelnik
c_number     dd 0.5
c_180        dd 180
a dd 3.5
b dd 7.1
uhel dd 29.0

; promenne pro funkci prefixSum
cisla        dd  1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15
delka        equ ;*** ZDE SPRAVNE DOPLNTE, TAK ABYSME UZ HODNOTU VE FUNKCI NEMUSELI UPRAVOVAT. 
                 ; POZOR! PRVKY POLE JSOU DWORDY ***
s_suma       db  "Suma prefixu je: ", 0
c_120        dd  120.0
s_true       db  "True.", EOL, 0
s_false      db  "False", EOL, 0

section .text
CMAIN:
  push ebp
  mov ebp, esp

  call mezikruzi
  call trojuhelnik
  call prefixSum

  mov esp, ebp
  pop ebp
  ret

mezikruzi:
  ; Vzorec:
  ; S = PI*(R*R - r*r), kde R znaci polomer vetsi kruznice, r znaci polomer mensi kruznice.
  ; Resena uloha spolecne.
  push ebp
  mov ebp, esp

  finit

  fld dword [r]     ; st0 = r
  fmul st0          ; st0 = r*r
  fld dword [R]     ; st0 = R,      st1 = r*r
  fmul st0          ; st0 = R*R,    st1 = r*r
  fsubrp            ; st0 = R*R-r*r
  fldpi             ; st0 = PI,     st1 = R*R-r*r
  fmulp             ; st0 = PI*(R*R-r*r)

  mov esi, s_obsah
  call WriteString
  call WriteDouble
  call WriteNewLine

  mov esp, ebp
  pop ebp
  ret

trojuhelnik:
  ; Vypocitejte obsah trojuhelniku pres uhel a dve strany.
  ; Trojuhelnik ma strany a, b, c. Strany "c" a "b" sviraji uhel alpha,
  ; "a" a "c" uhel beta a "b" a "a" uhel gamma.
  ; Vzorec:
  ;   S = 0.5*a*b*sin(gamma)
  ; Uhel uvazujte ve stupnich.
  ; Hodnoty pro uhel, stranu a a stranu b nactete v tomto poradi z uzivatelskeho vstupu (ReadDouble).
  ;
  ; Vysledky si muzete overit zde:
  ; http://vzorce-matematika.hys.cz/najit-obsah-trojuhelniku-pres-uhel-a-dve-strany.php#oo13
  push ebp
  mov ebp, esp
  finit
  ;  *** ZDE DOPLNTE VAS KOD ***
  ; Napoveda:
  ;   S = 0.5*a*b*sin(gamma)
  ;   1 = PI/180 rad
  ; Pozor! Instrukce fsin pracuje s radiany. Musite tedy stupne prevest na radiany.
  ;
  ; Urcite jste si take vsimli, ze hodnoty mate nactene v opacnem poradi, nez by se vam to idealne
  ; hodilo. Pouzijte tedy vhodnou instrukci a provedte swap(st0, st2). Takto budete mit
  ; uhel na vrcholu zasobniku.
  ;
  ; Cisla 0,5 a 180 mate definovane v sekci .data.






  ; Doplnte vypis hlasky s_vysledek, vysledku a hlasky s_jednotka


  mov esp, ebp
  pop ebp
  ret

prefixSum:
  ; Pracujte s polem cisel cisla. Delka tohoto pole je definovana promenou delka.
  ; Priklad jak prefix-sum funguje:
  ;   Uvazujte pole cisel (a, b, c, d, e, f).
  ;   prefixSum = (((((a+b)+c)+d)+e)+f)
  ;
  ; Neco navic: Na zaver si jeste vyzkousejte funkci fcomp, ktera umi porovnat hodnoty. Pokud se
  ; vami vypoctena hodnota bude rovnat 120 (promenna c_120), pak vypiste hlasku TRUE, jinak FALSE.
  ; Dale by se vam mohlo hodit: fstsw, and.

  push ebp
  mov ebp, esp
  finit
  ;  *** ZDE DOPLNTE VAS KOD ***




.end:
  mov esp, ebp
  pop ebp
  ret
